from sys_appends import *
import psycopg2
import src.vsql_core.utils.pickler.victor_pickler as victor_pickler


### THIS SHOULD USE THE COPY BUFFER!
def dump_data(cur, lines, table_name, doc_no):
    bdata = psycopg2.Binary(victor_pickler.pickle_data(lines))
    insert_stmt = "INSERT INTO {0} VALUES({1}, {2})".format(table_name,doc_no,bdata)
    cur.execute(insert_stmt)
    
def load_table(data_file, table_name = "documents_loaded"):
    lines = []
    doc_no = 0
    conn = psycopg2.connect('dbname={0}'.format(dbname))

    cur = conn.cursor()

    create_query = "DROP TABLE IF EXISTS {0}; CREATE TABLE {0}( eid int, featurized_docs bytea );".format(table_name)
    cur.execute(create_query)
    with open(data_file, "r") as f:
        for l in f:
            l = l.rstrip()
            if len(l) == 0:
                if len(lines) > 0:
                    dump_data(cur, lines, table_name, doc_no)
                    doc_no += 1
                lines = []
            else:
                lines.append(l)

    if len(lines) > 0:
        dump_data(cur, lines, table_name, doc_no)
        doc_no += 1

    print "Loaded {0} documents".format(doc_no)
    conn.commit()

if len(sys.argv) != 2:
    print "{0} <file in crf++ format>".format(sys.argv[0])
else:
    fname = sys.argv[1]
    print "Loading {0}".format(fname)
    load_table(fname)
