DELETE MODEL SPECIFICATION cut_model;

CREATE MODEL SPECIFICATION cut_model (
  model_type=(python) as (w),
  data_item_type=(int,int,float8) as (x,y,weight),   
  objective=examples.CUTS.stochast_cuts.loss, 
  objective_agg=SUM,
  grad_step=examples.CUTS.stochast_cuts.grad,
  bulk_grad=examples.CUTS.stochast_cuts.minibatch
);

CREATE MODEL INSTANCE dblife_cut_mi
  EXAMPLES dblife_cut(x,y,score)
  MODEL SPEC cut_model
  INIT_FUNCTION examples.CUTS.stochast_cuts.init
  STOP WHEN examples.CUTS.stochast_cuts.stopping_condition
;