"""
This module contains ell2 ball constraint avg function.
"""

import src.vsql_core.utils.victor_utils as victor_utils

def ell2_ball_constraint_avg_fnc(w, x, y, stepsize, w_hat, steps):
    """
    Calculates ell2 ball constraint avg
    @type w: vector
    @param w: model vector
    @type x: vector
    @param x: feature vector of the example
    @type y: number
    @param y: label of the example
    @type stepsize: double
    @param stepsize: step size
    @type w_hat: vector
    @param w_hat: w hat
    @type steps: number
    @param steps: number of steps
    """
    wx  = victor_util.dot(w, x)
    err = (wx - y)
    etd = - stepsize * err
    victor_util.add_and_scale(w, wx, etd)
    victor_util.incremental_average(w_hat, w, steps)
