import src.vsql_core.utils.victor_utils as victor_utils
import examples.LINEAR_MODELS.simple_linear as simple_linear
import math

def incremental_average_sparse(w_hat, w, steps, indexes):
   """
   Incremental average sparse function
   @type w_hat: vector
   @param w_hat: w hat vector
   @type w: vector
   @param w: model vector
   @type steps: double
   @param steps: steps of the incremental stage
   @type indexes: vector
   @param indexes: indexes 
   """
   if steps == 0:
        for i in range(len(w_hat)):
            w_hat[i] = w[i]
   else:
        steps = float(steps)
        for i in indexes:
            w_hat[i] = w[i] * 1.0/steps + steps/(steps + 1) * w_hat[i]

def ell2_ball_constraint_avg((m,mhat), (indexes, values, y)):
    wx  = victor_utils.dot_dss(m.w, indexes, values)
    err = (wx - y)
    etd = - m.stepsize * err
    victor_utils.scale_and_add_dss(m.w,indexes, values, etd)
    victor_utils.l2_project(m.w, m.B)	
    incremental_average_sparse(mhat.w, m.w, m.stepsize, indexes)
    m.take_step()
    return (m,mhat)

############################################################
### This the front end code for a particular model instance
###
def init():
   m  = simple_linear.LinearModel(41270,B=1.5)
   m2 = simple_linear.LinearModel(41270,B=1.5)
   return (m,m2)

def stopping_condition(s, loss):
    if not (s.has_key('state')):
        s['state'] = 0
    s['state'] += 1
    return s['state'] > 2
