#include "postgres.h"
#include "executor/executor.h"  /* for GetAttributeByName() */

#ifdef PG_MODULE_MAGIC
PG_MODULE_MAGIC;
#endif

PG_FUNCTION_INFO_V1(c_partition);

Datum
c_partition(PG_FUNCTION_ARGS)
{
  HeapTupleHeader  t = PG_GETARG_HEAPTUPLEHEADER(0);
  bool isnull;
  int row;
  int col;

  row = DatumGetInt32(GetAttributeByNum(t, 1, &isnull));
  col = DatumGetInt32(GetAttributeByNum(t, 2, &isnull));

  int partition = (row * 10 + col * 23) % 7;

  PG_RETURN_INT32(partition);
}
