DELETE MODEL SPECIFICATION low_rank_nopara;

CREATE MODEL SPECIFICATION low_rank_nopara (
  model_type=(python,numpy,numpy) as (w,L,R),
  data_item_type=(int,int,float8) as (rowr,col,rating),   
  objective=examples.factor_simple.factor_simple_numpy.se_loss, 
  objective_agg=RMSE,
  grad_step=examples.factor_simple.factor_simple_numpy.grad
);

CREATE MODEL INSTANCE lr_data
  EXAMPLES lr_data(row,col,rating)
  MODEL SPEC low_rank_nopara
  INIT_FUNCTION examples.factor_simple.factor_simple_numpy.netflix_init
  STOP WHEN examples.factor_simple.factor_simple_numpy.stopping_condition
  PARTITION examples.factor_simple.factor_simple_numpy.factor_partition;