DELETE MODEL SPECIFICATION low_rank_nopara;

CREATE MODEL SPECIFICATION low_rank_nopara (
  model_type=(python,numpy,numpy) as (w,L,R),
  data_item_type=(int,int,float8) as (rowr,col,rating),   
  objective=examples.factor_simple.factor_simple_pyrex.se_loss, 
  objective_agg=SUM,
  grad_step=examples.factor_simple.factor_simple_pyrex.grad,
  bulk_grad=examples.factor_simple.factor_simple_pyrex.bulkgrad
);

CREATE MODEL INSTANCE movielens10m
  EXAMPLES movielens10m(row,col,rating)
  MODEL SPEC low_rank_nopara
  INIT_FUNCTION examples.factor_simple.factor_simple_pyrex.movielens10m_init
  STOP WHEN examples.factor_simple.factor_simple_pyrex.stopping_condition
  PARTITION examples.factor_simple.factor_simple_pyrex.factor_partition
;
