DROP AGGREGATE IF EXISTS rmse(float8);

CREATE AGGREGATE rmse (float8)
(
    sfunc = float8_accum,
    stype = float8[],
    finalfunc = _float8_rmse,
    initcond = '{0,0,0}'
);

CREATE OR REPLACE FUNCTION _float8_rmse(float8[])
RETURNS FLOAT8 AS $$
	SELECT SQRT($1[2] / $1[1]);
$$ LANGUAGE SQL;


