from sys_appends import *
import psycopg2
import src.globals.constants as constants
import src.vsql_core.utils.pickler.victor_pickler as victor_pickler
import src.normalization.create_model as create_model
import collections
import src.normalization.create_model_helper as create_model_helper

FunctionDesc = collections.namedtuple('FunctionDesc', 'name function_body model_inst_name data_type data_params')

def mid_of_function_name(cur, f_desc):
    select_query = "SELECT {0} FROM {1} where {2} = '{3}';".format(constants.MID_FIELD,
                                                                   constants.VICTOR_GLOBAL_MODEL_ID_TABLE,
                                                                   constants.VICTOR_GLOBAL_INSTANCE,
                                                                   f_desc.model_inst_name)
    return get_single_tuple_result(cur, select_quer)

def model_instance_of_mid(cur, mid):
    select_query = "SELECT {0} FROM {1} where {2} = '{3}';".format(constants.VICTOR_GLOBAL_INSTANCE,
                                                                   constants.VICTOR_GLOBAL_MODEL_ID_TABLE,
                                                                   constants.MID_FIELD, mid)
                                                                   
    return create_model_helper.get_single_tuple_result(cur, select_query)

def build_read_model_query(mid, model_inst_name):
    q = "SELECT {0} FROM {1} where mid = {2}".format(','.join(f_desc.data_params),
                                                       model_inst_name,
                                                       mid)

    cur.execute(q)
    vals = cur.fetchone()
    v = [(d,vals[i]) for (i,d) in enumerate(f_desc.data_params)]
    print v
    conn.close()

def retrieve_model(mid, class_inst):
    conn         = create_model_helper.connect_db()
    cur          = conn.cursor()    
    model_inst_name   = model_instance_of_mid(cur, mid)
    cur.execute("select * from {0} where mid={1}".format(class_inst,mid))
    names = [(i,x.name) for (i,x) in enumerate(cur.description)]
    v     = cur.fetchone()
    
    def type_of_field(p):
        return create_model_helper.get_type_of_field_in_table(cur, p, class_inst)
    reserved_words = ["init_fnc", "train_fnc", "mid"]
    def non_reserved(x): 
        return not (x in reserved_words) 
    zz = [ v[i] for (i,x) in filter(lambda (i,x): not (x in reserved_words + ["mid"]), names)]
    if len(zz) == 1:
        return zz[0]
    else:
        return tuple(zz)

def build_read_model_to_gd(class_instance):
    fname = "cache_model_{0}".format(class_instance)
    v = """
    DROP FUNCTION IF EXISTS {0}(mid int); 
    CREATE FUNCTION {0}(mid int) RETURNS VOID
    AS $$
    import src.normalization.function_utils
    GD[mid] = src.normalization.function_utils.retrieve_model(mid, \"{1}\")
    $$ LANGUAGE plpythonu;
    """.format(fname, class_instance)
    return v

def build_apply(mid, class_instance, apply_import, apply_fn, ret_type):
    fname = "cache_model_{0}".format(class_instance)
    v = """
    DROP FUNCTION IF EXISTS {0}(mid int); 
    CREATE FUNCTION {0}(mid int) RETURNS {4}
    AS $$
    import src.normalization.function_utils, {2}
    GD[mid] = src.normalization.function_utils.retrieve_model(mid, \"{1}\")
    return {3}(GD[mid])
    $$ LANGUAGE plpythonu;
    """.format(fname, class_instance, apply_import, apply_fn, ret_type)
    return v

def build_crazy(mid, class_instance, fd):
    v = """
    DROP FUNCTION IF EXISTS {0}({6}); 
    CREATE FUNCTION {0}({6}) RETURNS {4}
    AS $$
    import src.normalization.function_utils, {2}
    if not SD.has_key(mid):
       SD[{5}] = src.normalization.function_utils.retrieve_model({5}, \"{1}\")
    return {3}(SD[mid], data)
    $$ LANGUAGE plpythonu;
    """.format(fname, class_instance, apply_import, apply_fn, ret_type,mid, fd.typed_str, fd.untyped_str)
    
    return v

print build_read_model_to_gd("supportvectormachine_numpyl2_instance")
print build_apply(107, "supportvectormachine_numpyl2_instance", "examples.NUMPY_L2.numpy_l2", "examples.NUMPY_L2.numpy_l2.dot", "float8")


def create_function_str(mid, f_desc):
    #TODO: this function needs to be in helper
    (param_type_str, param_call_str, param_full_str) = create_model.get_param_type_call_full_str(f_desc.data_params)
    import_str                                       = f_desc.function_body.get_import_statement()


    if data_type == constants.PYTHON_DATA_TYPE:
        import_str += ", {0}".format(constants.VICTOR_PICKLER)
        (pre_process_str, param_call_str) = unpickle_data_types_str(params, 1)
    else:
        pre_process_str = "\t" # pickling adds a tab
        
    query = """DROP FUNCTION IF EXISTS {0}({1}); 
    CREATE FUNCTION {0}({2}) RETURNS FLOAT8
    AS $$
    \t{3}
    \tif (SD.has_key({4})):
    \t\tmodel = SD[{4}]
    \telse:
    \t\tmodel = GD[{4}]
    \t\tSD[{4}] = model
    {5}
    \treturn {6}(model, {7})
    $$ LANGUAGE plpythonu;
    """.format(fname, param_type_str, param_full_str, import_str, mid, 
               pre_process_str, eval_fnc.get_qualified_name(), param_call_str)

    print query
    return query

    
def create_function(f_desc):
    conn         = connect_db()
    cur          = conn.cursor()
    mid          = mid_of_function_name(cur, f_desc)
    
    apply_function = create_function_str(fname, eval_fnc, model_inst_name, data_type, data_params, mid)
    #create apply_function
    cur.execute(apply_function)
    #insert function to the function global table
    insert_query = "INSERT INTO function_table VALUES('{0}', '{1}', {2}, '{3}')".format(fname,
                                                                                        model_inst_name,
                                                                                        mid,
                                                                                        apply_function)
    cur.execute(insert_query)
    conn.commit()
