import src.globals.constants as constants
import src.globals.global_types as global_types
import src.globals.victor_exceptions as victor_exceptions

## TODO: Move this to a util directory
def strip_braces(s):
    s = s.lstrip(' {')
    return s.rstrip(' }')

# TODO: Fix this list up!
escapable_types = ["bytea", "string", "text"]
def escape_type(label, label_type):
    if label_type == "bytea":
        return "bytearray({0})".format(repr(label))    
    elif label_type in ["string","text"]:
        return "'{0}'".format(label)
    return label

def build_label_test_function(label_no, label, label_type, base_name):
    fn_name = "label_function_{0}_{1}".format(base_name, label_no)
    label   = escape_type(label, label_type)
    print "LABEL {0}".format(label)
    
    v= """DROP FUNCTION IF EXISTS {0} ({1}) CASCADE;
    CREATE FUNCTION {0} (label {1})
    \tRETURNS int
    AS $$
    \t if cmp(label,{2}) == 0:
    \t    return 1
    \t else:
    \t    return -1
    $$ LANGUAGE plpythonu;
    """.format(fn_name, label_type, label)
    print v
    return (label, fn_name,v)

def build_ova_structures(cur, model_instance_name, param_dict):    
    # Figure out if this is an OVA model
    # Currently does nothing.
    if param_dict.has_key(constants.OVA):
        label_attr = param_dict[constants.PARSER_LABEL_ATTR]
        label_type = param_dict[constants.PARSER_LABEL_TYPE]
        label_view = strip_braces(param_dict[constants.PARSER_LABEL_SET_TABLE])
        
        print "*** OVA *** label_attr={0} lable_type={1} label_query={2}".format(label_attr, label_type, label_view)
        cur.execute(label_view)
        descs = cur.description
        label_set = [ str(x) for (x,) in cur.fetchall()]
        label_functions = [build_label_test_function(i, l, label_type, model_instance_name) for (i,l) in enumerate(label_set) ]
        # Build the functions
        to_create            = '\n'.join([ v for (l,fname,v) in label_functions])
        cur.execute(to_create)
        
        label_function_names = [(l,fname) for (l,fname,v) in label_functions]
        
        return global_types.OVADescription(label_attr=label_attr, label_type=label_type, label_functions=label_function_names)
    else:
        print "*** NO OVA FOUND ***"
        return None

# def test_handler():
#     print build_label_test_function("chicken", "int", "names")
