# Todo factor this code.
import collections
import src.normalization.create_model as create_model
import src.normalization.delete_model as delete_model
import src.vsql_core.utils.function_utils as function_utils

# These are all tasks for our parser, which export the "normalize" method
# they may return a work item to be planned and then executed
#.
# inheritance seemed like overkill here, but probably not....
class  ParserModelInstance:
    def __init__(self, name, params):
        self.name = name
        self.params = params
        
    def normalize(self):
        return create_model.create_model_instance(self.params)

class ParserModelSpecification:
    def __init__(self, name, params):
        self.name = name
        self.params = params

    def normalize(self):
        create_model.create_model(self.params)

class ParserModelAppSpecification:
    def __init__(self, name, params):
        self.name = name
        self.params = params

    def normalize(self):
        function_utils.create_model_application(self.params)


class ParserDeleteModelSpecification:
    def __init__(self, name):
        self.name = name

    def normalize(self):
        delete_model.delete_model_specification(self.name)
        

class PythonFunction:
    def __init__(self, qualified_names):
        self.qualified_name = '.'.join(qualified_names)
        length = len(qualified_names)
        assert(length > 0)
        self.function_name = qualified_names[length - 1]
        if length > 1:
            self.module_name = '.'.join(qualified_names[0:length - 1])
        else:
            self.module_name = None
            
    def get_import_statement(self):
        if self.module_name is None:
            return ""
        else:
            return "import {0}".format(self.module_name)

    def get_qualified_name(self):
        return self.qualified_name

    
    def get_serialization_string(self):
        return "{}".format(self.qualified_name)

class PSQLFunction:
    def __init__(self, libpath, fname):
        self.libpath = libpath
        self.fname   = fname
        assert(self.fname is not None)
        
    def get_libpath(self):
        if self.libpath is None:
            return "$libdir"
        else:
            return self.libpath
        
    def get_fname(self):
        return self.fname
