import sys
import traceback
import antlr3
import antlr3.tree
from VictorParserLexer import VictorParserLexer
from VictorParserParser import VictorParserParser
import constants
import create_model

def convert_to_dict(arr):
    param_dict = dict()
    for t in arr:
        for i in range(0, len(t), 2):
            param_dict[t[i]] = t[i + 1]

    return param_dict
    

#def main(argv, otherArg=None):
char_stream = antlr3.ANTLRInputStream(sys.stdin)
lexer = VictorParserLexer(char_stream)
tokens = antlr3.CommonTokenStream(lexer)
parser = VictorParserParser(tokens)
r = parser.query()

for q in r.value:
    param_dict = convert_to_dict(q)

    if param_dict[constants.PARSER_FUNCTION_FIELD] == constants.CREATE_MODEL_FNC_NAME:
        create_model.create_model(param_dict)
    elif param_dict[constants.PARSER_FUNCTION_FIELD] == constants.CREATE_MODEL_INSTANCE_FNC_NAME:
        create_model.create_model_instance(param_dict)


# nodes = antlr3.tree.CommonTreeNodeStream(root)
# nodes.setTokenStream(tokens)
# eval = Eval(nodes)
# eval.prog()

# char_stream = ANTLRFileStream(sys.argv[1])
# lexer = TestLexer(char_stream)
# tokens = CommonTokenStream(lexer)
# parser = TestParser(tokens);

# try:
#     z = parser.create_model().value
#     print z
# except RecognitionException:
#     traceback.print_stack()

#main()
