import time


class Managers:
    hard_worker = False
    debug       = False
    def __init__(self, jobs):
        self.jobs = jobs
        
    def more_work(self):
        for j in self.jobs:
            if j.hard_worker:
                return True
            else:
                if j.more_work():
                    return True
        return False

class WorkSet(Managers):
    hard_worker = False
    def __init__(self, jobs):
        self.jobs = jobs

    # Set runs all of its jobs in one
    # round, but may have others below it that are lists
    def get_round(self):
        if self.debug:
            print "\t Getting Round [WorkSet]"
        this_round    = []
        has_more_work = []
        for j in self.jobs:
            if self.debug:
                print "\t hard_worker={} {}".format(j.hard_worker, j)
            if j.hard_worker:
                this_round.append(j)
                # All Hardworkers are run once by convention
            else:
                if self.debug:
                    print "\t Getting Round Lower"
                lower_jobs = j.get_round()
                if j.more_work():
                    has_more_work.append(j)
                this_round.extend(lower_jobs)
        self.jobs = has_more_work
        return this_round

    
class WorkList(Managers):
    hard_worker = False
    def __init__(self, jobs):
        self.jobs = jobs

    # Lists run their jobs one at a time until they are completed
    def get_round(self):
        if self.debug:
            print "\t Getting round from WorkList"
        if len(self.jobs) == 0:
            return []
        else:
            first_job = self.jobs[0]
            if first_job.hard_worker:
                self.jobs = self.jobs[1:]
                return [first_job]
            else:
                this_round = first_job.get_round()
                # If this guy is done, move him out of the way
                if not first_job.more_work():
                    self.jobs = self.jobs[1:]
                return this_round        
####################        
