"""
This module extends MMapWrapper to make it expandable for writes
"""

import mmap

initial_size = int(1e6)

WRITE_MODE = 2
READ_MODE = 1

class MMapWrapper(mmap.mmap):
    def __new__(cls, file_no, length, is_write, debug = False):
        obj = super(MMapWrapper, cls).__new__(cls, file_no, length)
        obj.seek(0)
        if is_write == WRITE_MODE:
            if debug:
                obj.resize(16)
            else:
                obj.resize(initial_size)

        return obj

    """
    Writes given data to the mmap
    If we run out of space, buffer size is expanded
    @type data: data
    @param data: data to write to the mmap
    """
    def write(self, data):
        if(self.tell() + len(data) >= self.size()):
            cur_length = self.size()
            self.resize(cur_length * 2)

        mmap.mmap.write(self, data)
