"""
This module is an extension to compile psql_util
"""

from distutils.core import setup
from distutils.extension import Extension
from Cython.Distutils import build_ext

ext_include_dirs = ["src/vsql_core/utils/factor_utils", "."]

ext_modules = [
    Extension("victor_buffer", ["victor_buffer.pxd", "victor_buffer.pyx"], include_dirs = ext_include_dirs), 
    Extension("tuple_processor", ["tuple_processor.pyx"], include_dirs = ext_include_dirs), 
    Extension("data_types", ["data_types.pyx"], include_dirs = ext_include_dirs),
    Extension("psql_util", ["psql_util.pyx"], include_dirs = ext_include_dirs),
    Extension("atomic_data_processor", ["atomic_data_processor.pyx"], include_dirs = ext_include_dirs)]

setup(
  name = 'Factor Parser',
  packages = ['src.vsql_core.utils.factor_utils'],
  cmdclass = {'build_ext': build_ext},
  ext_modules = ext_modules
)
