"""
This is the executor for a single calass in an OVA plan (or a regression plan)
"""
import sys_appends
import collections # for stop state
#import generate_plan
from multiprocessing import Pool
import psycopg2
import time

######################################################
## This is a glorified SQL Execution thread handler
## It just takes in a SQL executor and returns a work tuple
class PlanExecutor:
    def __init__(self, w):
        """
        Initializes the class
        """
        self.plan_id = w.plan_id
        self.conn    = psycopg2.connect(w.connect_str)
        self.setup_q = w.setup_query
        self.plan    = w.plan

        self.conn.set_isolation_level(psycopg2.extensions.ISOLATION_LEVEL_AUTOCOMMIT)
        self.psql = self.conn.cursor()

        
        
    def go(self):
        """
        Runs
        """
        t0 = time.time()
        print "[PlanExecutor %d] Start" % self.plan_id
        self.psql.execute("SELECT library_setup();" + self.setup_q)

        [(stop_condition_import_string, stop_condition_fname), body, loss_eval, footer] = self.plan
        
        # import the module for the stop condition
        exec stop_condition_import_string
        print "[PlanExecutor %d] setup complete" % (self.plan_id)
        loss = None
        stop_state = dict()
        grounded_loss = "{0}(stop_state, loss)".format(stop_condition_fname)
        epoch = 1
        while not eval(grounded_loss):
            # Execute the refinement step (and time it)
            t1 = time.time()
            self.psql.execute(body)
            t2 = time.time()

            # Compute the current loss 
            if loss_eval is not None:
                self.psql.execute(loss_eval)
                (loss,) = self.psql.fetchone()

            print "[PlanExecutor {0}] epoch={1} time={2} loss={3}".format(self.plan_id, epoch, t2- t1, loss)
            # End of the Epoch bookkeeping
            epoch += 1
                                                                 
        self.psql.execute(footer)
        print "[PlanExecutor:%d] Finished took %d seconds" % (self.plan_id,time.time() - t0)

    def close(self):
        """
        Closes
        """
        self.conn.close()


def perform_work(w):
    pe = PlanExecutor(w)
    pe.go()
    pe.close()
    return w.plan_id
