"""
This is responsible for building the metadata tables used by
VictorSQL to maintain multiple model descriptions and model
instances.
"""

tuple_values = ["name", "objective", "objective_item", "grad", "prox", "model_type", "data_type"]
types_names  = ["model_type", "data_type"]
def make_create_model_statements(l):
    """
    Creates model table and insert it into the Victor_Models table

    @type l: vector
    @param l: contains index and values in the vector

    @rtype: string
    @return: insert model and create model table queries
    """
    d = dict();
    for (k,v) in l:
        d[k] = v
    vals = []
    for t in tuple_values:
        if t in d:
            if t in types_names:
                vals.append('(' + ','.join(d[t]) + ')')
            else:
                vals.append(d[t])
        else:
            vals.append("NULL")
    ret = "INSERT INTO Victor_Models VALUES (" +','.join(vals) + ");\n"
    # now build the table
    ret += "CREATE TABLE " + d["name"] + "(model_name varchar(1024), instance_name varchar(1024),\n"
    ret += "\tmodel_instance_id int, data_query varchar(4096),\n\t"
    model_t = d["model_type"]
    zz   = ["serialized_model_" + str(i) + " " + model_t[i] for i in range(len(model_t))]
    ret += ',\n\t'.join(zz) + ',\n'
    ret += "\tFOREIGN KEY (model_name) REFERENCES Victor_Models(name),\n"
    ret += "\tPRIMARY KEY (instance_name));"
    return ret

def make_create_model_instance(l):
    """
    Creates INSERT statement for the given model instance
    @type l: tuple
    @param l: tuple that contains name, model name data view, k, values and initial value
    """
    (name, mname, (data_view,k,vals), initial_model) = l
    ret =  "INSERT INTO Victor_global_instances(model_name) VALUES ('" + name + "');\n";
    mid_query = "SELECT mid FROM Victor_global_instances where model_name = '" + name + "'";
    #ret += "INSERT INTO " + mname + " VALUES (" 
    
