#include <map>

typedef std::map<const char*, void*> gd_type;
typedef gd_type::iterator gd_it;

void*
get_instance() {
  return (void*) new gd_type();
}

extern "C"
void*
check_init(void* gd) {
  return (gd == NULL) ? get_instance() : gd;
}

extern "C"
void *
get_key(void *_pgd, const char* name) {
  gd_type *gd = (gd_type*) _pgd;
  gd_it it = gd-> find(name);
  return (it == gd->end()) ? NULL : it->second;
}

extern "C"
void
set_key(void *_pgd, const char *name, void *value) {
  gd_type *gd = (gd_type*) _pgd;
  gd->insert( std::pair<const char*, void*> (name,value) );
}
