-- These are routines to move around the factored models
DROP FUNCTION IF EXISTS permute_and_slice_data(text,int,text,int, int,int) CASCADE; 
CREATE OR REPLACE FUNCTION permute_and_slice_data(dbname text,seed int, query text, nslices int, epoch int, mid int) 
RETURNS VOID
AS $$
   from src.vsql_core.utils.factored_parser.parser_helper import permute_and_slice_data
   # Test Data
   permute_and_slice_data(dbname,seed, query, nslices, epoch, mid)
$$ LANGUAGE plpythonu;

DROP FUNCTION IF EXISTS permute_and_slice_model(text,int,text,int, int,int) CASCADE; 
CREATE OR REPLACE FUNCTION permute_and_slice_model(dbname text,seed int, query text, nslices int, epoch int, mid int) RETURNS VOID
AS $$
   from src.vsql_core.utils.factored_parser.parser_helper import permute_and_slice_model
   # Test Data
   permute_and_slice_model(dbname,seed, query, nslices, epoch, mid)
$$ LANGUAGE plpythonu;


DROP FUNCTION IF EXISTS retrieve_sparse_model(int, int, int, int, int) CASCADE; 
CREATE FUNCTION retrieve_sparse_model(mid int, epoch_sign int, nsplits int, round int, chunk int)
RETURNS VOID
AS $$
   from src.vsql_core.utils.factored_parser.parser_helper import retrieve_sparse_model
   (gd,gd_2) = retrieve_sparse_model('test_victor', mid, epoch_sign, nsplits, round, chunk)
   GD['sparse_model_info'] = gd_2
   GD['lr_model'] = gd
$$ LANGUAGE plpythonu;


DROP FUNCTION IF EXISTS update_segment_sparse(int, int, int, int, int) CASCADE; 
CREATE FUNCTION update_segment_sparse(mid int, epoch_sign int, nsplits int, round int, chunk int)
RETURNS VOID
AS $$
   from src.vsql_core.utils.factored_parser.parser_helper import update_sparse_segment
   [L,R,moviemean,stepsize,B,B2] = GD['lr_model']
   update_sparse_segment('test_victor', mid, epoch_sign, nsplits, round, chunk, L, R, moviemean, stepsize, B, B2)   
$$ LANGUAGE plpythonu;

DROP FUNCTION IF EXISTS store_model(int) CASCADE; 
CREATE FUNCTION store_model(mid int)
RETURNS VOID
AS $$
   from src.vsql_core.utils.factored_parser.parser_helper import store_model
   [L,R, mean, stepsize, b, z] = GD['lr_model']
   store_model('test_victor', mid, L, R, mean, stepsize, b, z)
$$ LANGUAGE plpythonu;



DROP FUNCTION IF EXISTS sparse_rebuild_model(int, int, int) CASCADE; 
CREATE FUNCTION sparse_rebuild_model(mid int, epoch_sign int, nsplits int)
RETURNS VOID
AS $$
   from parser_helper import sparse_rebuild_model
   sparse_rebuild_model('test_victor', mid, epoch_sign, nsplits)   
$$ LANGUAGE plpythonu;



DROP FUNCTION IF EXISTS retrieve_sparse_model_simple(mid int) CASCADE; 
CREATE FUNCTION retrieve_sparse_model_simple(mid int)
RETURNS VOID
AS $$
   from parser_helper import retrieve_sparse_model_simple
   GD['lr_model'] = retrieve_sparse_model_simple('test_victor', mid)   
$$ LANGUAGE plpythonu;


