"""
This module implements VictorBuffer
"""

cdef class VictorBuffer:
    def __init__(self, b, debug = False):
        self.b = <bytes> b
        self.debug = debug
        self.max_len = len(b)
        self.current_index = 0

    """
    Advances current index with the given i
    @type i: number
    @param i: number to advance current index
    """
    cpdef advance_ci(self, int i):
        self.current_index = self.current_index + i

    """
    Returns we have more data to process or not
    @rtype: bool
    @return: True if we have more data in the buffer to process, False otherwise
    """
    cpdef process_more(self):
        if self.current_index < self.max_len:
            return True
        else:
            return False
    
