import sys
sys.path.append('/scratch.1/VICTOR/')
sys.path.append('/scratch.1/chrisre/VICTOR/')

import generate_plan
from multiprocessing import Pool
import psycopg2
import time

# This generates and executes one-versus-all-plans for V-SQL

######################################################
## This is a glorified SQL Execution thread handler
class PlanExecutor:
    def __init__(self, plan_id, connect_str, plan_str):
        self.conn = psycopg2.connect(connect_str)
        self.conn.set_isolation_level(psycopg2.extensions.ISOLATION_LEVEL_AUTOCOMMIT)
        self.psql = self.conn.cursor()
        self.plan = plan_str
        self.plan_id = plan_id
        
    def go(self):
        t0 = time.time()
        print "[PlanExecutor:%d] Start" % self.plan_id
        self.psql.execute("SELECT library_setup();")
        self.psql.execute(self.plan)
        print "[PlanExecutor:%d] Finished took %d seconds" % (self.plan_id,time.time() - t0)

    def close(self):
        self.conn.close()

########################
# Main working thread
def execute_work(work_tuple):
    (plan_id, connect_str, plan) = work_tuple
    plan_id = plan_id + 1
    pe = PlanExecutor(plan_id, connect_str, plan)
    pe.go()
    pe.close()
    return plan_id


# This is currently hardcoded for forest cover
# and ell2
def ova_plan(print_only, connect_str, nprocesses):
    base_mid     = 10
    epochs       = 4
    stepsize     = 1e-2
    diminish     = 0.8
    dim          = 54
    create_function = 'create_initial_model_with_bias'
    iname_table  = 'ell_two_model_instance'
    curried_grad = 'curried_bias_grad_g'
    grad         = 'ell_two_bias_grad'
    prox         = None    

    work_list = []
    for i in range(1,8):
        mid       = base_mid + i        
        setup_query = "DELETE FROM %s where mid=%d;\n" % (iname_table, mid)        
        setup_query = setup_query + "INSERT INTO %s VALUES (%d, %s(%d));\n" % (iname_table, mid, create_function, dim)
        data_query   = "SELECT eid, CAST((label = %d) AS INT) as label, vec FROM forest_normalized" % i    
        P = generate_plan.Python_Plan(mid, epochs, stepsize, diminish, iname_table, curried_grad, grad, data_query, prox)
        if print_only:
            print setup_query
            print data_query
            print P.incremental_plan()
        else:
            work_list.append((i, connect_str, setup_query + P.incremental_plan()))

    pool = Pool(processes=nprocesses)            
    print pool.map(execute_work, work_list)
    
ova_plan(False, 'dbname=chrisre', 4)
