"""
This module contains function to clean tables from PostgreSQL.
"""

from multiprocessing import Pool
import time
import sys, getopt
import random

import sys_appends

import psycopg2

def clean_tables(stem):
    """
    Cleans all tables in the database whose names are similar to the given parameter name
    @type stem: string
    @param stem: name of the table where similar names would be cleaned from the database
    """
    connect_str = 'dbname=' + sys_appends.dbname
    conn = psycopg2.connect(connect_str)
    psql = conn.cursor()
    psql.execute("SELECT tablename from pg_tables where tablename LIKE '%s%%'" % (stem))
    for (tname,) in psql.fetchall():
        print "DROP TABLE %s;" % (tname)

clean_tables('staging_data')
clean_tables('epoch')
clean_tables('victor')
