
-------------------------
--- BASIC EXECUTION
-------------------------
SELECT initialize_model(15, 480189, 17770, CAST(1.5 as FLOAT8), CAST(3.6040927 AS FLOAT8), CAST(0.8 AS FLOAT8));

-- Run 1 epoch
select count(*) FROM (select take_step(row - 1, col - 1, rating) from lr_data) as t;
select SQRT(SUM(mse(row - 1, col - 1, rating)))/SQRT(COUNT(*)) from probe_table;


--  max row 480189 | max col 17770
--- BEGIN EXECUTION
--- Parameters
--- data_size, nRows, nCols, seed 
--- (roundid,chunkid)
--- nsplits


--- V-SQL parallel
--- Initialize
--- CREATE TABLE lr_model_instance (mid int, l float8[][], r float8[][], moviemean float8, stepsize float8, b float8, primary key (mid));
SELECT initialize_model(15, 480189, 17770, CAST(1.5 as FLOAT8), CAST(3.6040927 AS FLOAT8), CAST(0.8 AS FLOAT8));
SELECT store_model(mid) 

-- Single thread of execution does the following
-- 1. Retrieve the model
-- 2. Retrieve the data (in the correct order) and take a step (
-- 3. store back the fragment

-- Step 1. Retrieve the model and do init
 -- NB: string is much faster
SELECT retrieve_model_instance_string(mid) -- modelid=7

 -- creates the necessary permutations
SELECT create_permuations(nRows, nCols, seed)

---------
-- Step 2. Retrieve the data and take a step
-- TODO: Shuffle the data appropriately
select count(*) FROM (select take_step(row - 1, col - 1, rating) 
       from lr_data 
       WHERE round(nsplits,nRows,nCols,i,j) = roundid AND    
       	     chunk(nsplits,nRows,nCols,i,j) = chunkid
--     ORDER BY RANDOM()    
       ) as t;
-- Step 3. 
select update_fragment(max_rank, nsplits, nrows, ncols, chunkid, roundid, mid)