-- CREATE MODEL LR_model (
-- model = (float8[][], float8[][]), data_type=(int,int,float8)
-- object_item = ell_two_item *** FIX THIS. Doesn't quite work ***
-- gradient=lr_gradient, prox=lr_max_norm,

-- Dependency idea. We can annotate the related parts of the model.
-- grad [[i,*],[*,j]]
-- prox [[i,*],[*,j]]
-- [ changed ] 

-- Executor


DROP FUNCTION IF EXISTS create_permutation(int, int) CASCADE; 
CREATE FUNCTION create_permutation(n int, seed int)
RETURNS VOID
AS $$
import random
random.seed(seed)
the_map = range(n)
random.shuffle(the_map)
GD['permutation'] = the_map
$$ LANGUAGE plpythonu;

DROP FUNCTION IF EXISTS apply_permutation(int) CASCADE; 
CREATE FUNCTION apply_permutation(i int)
RETURNS int
AS $$
the_map = GD['permutation']
return the_map[i]
$$ LANGUAGE plpythonu STABLE;

DROP FUNCTION IF EXISTS round(int, int, int, int, int) CASCADE; 
CREATE FUNCTION round(nsplits int, int nrows, int ncols, row int, col int)
RETURNS INT
AS $$
	row_bucket_size = nrows/nsplits
	col_bucket_size = ncols/nsplits
	row_bucket = row/row_bucket_size
	col_bucket = col/col_bucket_size
	return col_bucket - row_bucket
$$ LANGUAGE plpythonu STABLE;

DROP FUNCTION IF EXISTS chunk(int, int, int, int, int) CASCADE; 
CREATE FUNCTION chunk(nsplits int, int nrows, int ncols, row int, col int)
RETURNS INT
AS $$
	row_bucket_size = nrows/nsplits
	col_bucket_size = ncols/nsplits
	row_bucket = row/row_bucket_size
	col_bucket = col/col_bucket_size
	return col_bucket
$$ LANGUAGE plpythonu STABLE;



--- BEGIN EXECUTION
--- Parameters
--- data_size, nRows, nCols, seed 
--- (roundid,chunkid)
--- nsplits
SELECT create_permuation($data_size, $seed)

-- then a single thread executing block k would say:
SELECT i,j,rating 
FROM LR_DATA 
WHERE round(nsplits,nRows,nCols,i,j) = roundid AND    
      chunk(nsplits,nRows,nCols,i,j) = chunkid
ORDER BY RANDOM()

-- and store int eh table.

-- also we can interleave execution with threads in other contexts.
-- 
-- FOR ROUND 1=1,..,r
SELECT COUNT(*) FROM 
(SELECT curried_step(1,1e-2, low_rank(1,i,j,label)) 
FROM LR_DATA 
ORDER BY RANDOM())
WHERE ROUND(i,j) = k -- manually verified that this gets pushed down
 -- which we're in end. 
GROUP BY CHUNK(i,j) 
ORDER BY RANDOM()
-- END ROUND
-- So it seems like we need the following two CHUNK AND ROUND
-- AND We need two permutations PI_ROW, PI_COLUMN and we actually write this.
SELECT COUNT(*) 
SELECT PROX(1, alpha, curried_step(1, alpha, c_lr_grad(1, vec, label)) )
FROM 
(
SELECT pi_row(i) as pri,  pi_row(j) as prj, rating
FROM LR_DATA
ORDER BY pri,prj
)  T
WHERE ROUND(T.pri,T.prj) = k 
-- manually verified that this gets pushed down
 -- which we're in end. 
GROUP BY CHUNK(T.pri,T.prj) 