import timeit
import time
import array
from multiprocessing import Process, Lock, Manager, Value
import generic_manager.test_class as test_class
import generic_manager.class_registerer as class_registerer

length_of_vec = 1000000
num_of_process = 16
segment_size_of_process = length_of_vec / num_of_process

def write_method(id, arr):
    p_id = id.value
    start_index = segment_size_of_process * p_id
    for i in range(start_index, start_index + segment_size_of_process):
        arr.set(i, 2 * i)

def read_method(id, arr):
    p_id = id.value
    start_index = segment_size_of_process * p_id
    for i in range(start_index, start_index + segment_size_of_process):
        val = arr.get(i)

def write_method_array(id, arr):
    p_id = id.value
    start_index = segment_size_of_process * p_id
    for i in range(start_index, start_index + segment_size_of_process):
        arr[i] = 2 * i

def read_method_array(id, arr):
    p_id = id.value
    start_index = segment_size_of_process * p_id
    for i in range(start_index, start_index + segment_size_of_process):
        val = arr[i]

def write_method_array_wint(id, arr):
    start_index = segment_size_of_process * id
    for i in range(start_index, start_index + segment_size_of_process):
        arr[i] = 2 * i

def read_method_array_wint(id, arr):
    start_index = segment_size_of_process * id
    for i in range(start_index, start_index + segment_size_of_process):
        val = arr[i]

def read_and_modify_test_class_with_manager_multi_process():
    manager = class_registerer.ClassManager()
    manager.start()
    x_arr = manager.get_shared_arr(length_of_vec)

    p_s = []

    for i in range(num_of_process):
        num = manager.Value('i', i)
        p = Process(target=write_method, args=(num, x_arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[TestArrayManagerMultiProcess] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    p_s = []

    for i in range(num_of_process):
        num = manager.Value('i', i)
        p = Process(target=read_method, args=(num, x_arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[TestArrayManagerMultiProcess] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_array_with_manager_multi_process():
    manager = Manager()
    arr = manager.Array('i', range(length_of_vec), lock=False)

    p_s = []

    for i in range(num_of_process):
        num = manager.Value('i', i)
        p = Process(target=write_method_array, args=(num, arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[ArrayManagerMultiProcess] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    p_s = []

    for i in range(num_of_process):
        num = manager.Value('i', i)
        p = Process(target=read_method_array, args=(num, arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[ArrayManagerMultiProcess] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_array_obj_with_manager_single_process():
    manager = class_registerer.ArrayClassManager()
    manager.start()
    arr = manager.get_shared_arr()

    t = time.time()
    for i in range(length_of_vec):
        arr.set(i, 2 * i)
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[ArrayObjManagerSingleProcess] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()
    for i in range(length_of_vec):
        val = arr.get(i)
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[ArrayObjManagerSingleProcess] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_array_with_manager_single_process():
    manager = Manager()
    arr = manager.Array('i', range(length_of_vec), lock=False)

    t = time.time()
    for i in range(length_of_vec):
        arr[i] = 2 * i
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[ArrayManagerSingleProcess] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()
    for i in range(length_of_vec):
        val = arr[i]
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[ArrayManagerSingleProcess] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_test_class_with_manager_single_process():
    manager = class_registerer.ClassManager()
    manager.start()
    arr = manager.get_shared_arr(length_of_vec)

    t = time.time()

    for i in range(length_of_vec):
        arr.set(i, 2 * i)

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[TestArrayManagerSingleProcess] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()

    for i in range(length_of_vec):
        val = arr.get(i)

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[TestArrayManagerSingleProcess] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_test_class():
    arr = test_class.TestArrayClass(length_of_vec)

    t = time.time()
    for i in range(length_of_vec):
        arr.set(i, 2 * i)
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[TestArrayClass] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()
    for i in range(length_of_vec):
        val = arr.get(i)
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[TestArrayClass] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_array():
    arr = array.array('i', [-1 for i in range(length_of_vec)])

    t = time.time()
    for i in range(length_of_vec):
        arr[i] = 2 * i
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[Vector] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()
    for i in range(length_of_vec):
        val = arr[i]
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[Vector] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

# # import Queue
# # q = Queue.Queue()

# # t = time.time()

# # for i in range(100000):
# #     q.put(i)

# # e = time.time()
# # print ("time: {0}".format(e - t))


# # import multiprocessing
# # m = multiprocessing.Manager()
# # q = m.Queue()

# # t = time.time()

# # for i in range(100000):
# #     q.put(i)

# # e = time.time()
# # print ("time: {0}".format(e - t))

# # q = []

# # t = time.time()

# # for i in range(100000):
# #     q.append(i)

# # e = time.time()
# # print ("time: {0}".format(e - t))

# # q = m.list()

# # t = time.time()

# # for i in range(100000):
# #     q.append(i)

# # e = time.time()
# # print ("time: {0}".format(e - t))



# # print ("Managed q = ", timeit.timeit(stmt="map(q.put, [i for i in range(10000)])", setup="import multiprocessing;m = multiprocessing.Manager();q = m.Queue()", number=10))
# # print ("Normal q = ", timeit.timeit(stmt="map(q.put, [i for i in range(10000)])", setup="import Queue;q = Queue.Queue()", number=10))

# # print ("Managed l = ", timeit.timeit(stmt="map(q.append, [i for i in range(10000)])", setup="import multiprocessing;m = multiprocessing.Manager();q = m.list()", number=10))
# # print ("Normal l = ", timeit.timeit(stmt="map(q.append, [i for i in range(10000)])", setup="q = []", number=10))

# import multiprocessing
# from multiprocessing.managers import SyncManager

# m=SyncManager()
# m.start()
# t = m.Array('i',[1, 2, 3, 4, 5])
# x = t.value
# x.append(12)
# t[2] = 3
# l = m.list()
# l.append(12)

# print "Managed array = ", timeit.timeit(stmt="map(q.put, xrange(10000))", setup="import multiprocessing;m = multiprocessing.Manager();q = m.Array('i', []);", number=10)
# print "Normal array = ", timeit.timeit(stmt="map(q.Append, xrange(10000))", setup="import array;q = array.array('i', [])", number=10)



global_dict = dict()


def write_dict(id, arr):
    p_id = id.value
    arr = global_dict[p_id]
    start_index = p_id * segment_size_of_process
    for i in range(segment_size_of_process):
        arr[i] = 2 * (i + start_index)
    # do we need this?
    global_dict[p_id] = arr

def read_dict(id, arr):
    p_id = id.value
    arr = global_dict[p_id]
    for i in range(segment_size_of_process):
        val = arr[i]

def read_and_modify_global_dict_multiple_process():
    for i in range(num_of_process):
        global_dict[i] = array.array('i', [-1 for t in range(segment_size_of_process)])

    p_s = []

    for i in range(num_of_process):
        num = Value('i', i)
        arr = []
        p = Process(target=write_dict, args=(num, arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[GlobalDict] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    p_s = []

    for i in range(num_of_process):
        num = Value('i', i)
        arr = []
        p = Process(target=read_dict, args=(num, arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[GlobalDict] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_global_dict_single_process():
    for i in range(num_of_process):
        global_dict[i] = array.array('i', [-1 for t in range(segment_size_of_process)])

    t = time.time()

    for i in range(num_of_process):
        arr = global_dict[i]
        start_index = i * segment_size_of_process
        for j in range(segment_size_of_process):
            arr[j] = 2 * (j + start_index)

        #do we need this?
        global_dict[i] = arr

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[GlobalDictSingle] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()
    for i in range(num_of_process):
        arr = global_dict[i]
        for j in range(segment_size_of_process):
            val = arr[j]
            arr[j] = 2 * (j + start_index)

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[GlobalDictSingle] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_shared_ctypes_multi_process():
    import multiprocessing.sharedctypes as sc
    import multiprocessing, time
    from ctypes import c_double
    arr = sc.Array(c_double, length_of_vec, lock=False)

    p_s = []

    for i in range(num_of_process):
        p = Process(target=write_method_array_wint, args=(i, arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[CTypes_Array_Multi] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    p_s = []

    for i in range(num_of_process):
        p = Process(target=read_method_array_wint, args=(i, arr))
        p_s.append(p)

    t = time.time()
    for p in p_s:
        p.start()

    for p in p_s:
        p.join()

    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[CTypes_Array_Multi] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

def read_and_modify_shared_ctypes_single_process():
    import multiprocessing.sharedctypes as sc
    import multiprocessing, time
    from ctypes import c_double
    arr = sc.Array(c_double, length_of_vec, lock=False)

    t = time.time()
    for i in range(length_of_vec):
        arr[i] = 2 * i
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[CTypes_Array_Single] write takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    t = time.time()
    for i in range(length_of_vec):
        val = arr[i]
    e = time.time()
    elapsed_time = e - t
    element_per_sec = length_of_vec / elapsed_time
    print ("[CTypes_Array_Single] read takes {0}, {1} element/sec".format(elapsed_time, element_per_sec))

    

read_and_modify_global_dict_multiple_process()
read_and_modify_global_dict_single_process()
read_and_modify_shared_ctypes_single_process()
read_and_modify_shared_ctypes_multi_process()
read_and_modify_array()
read_and_modify_array_obj_with_manager_single_process()
read_and_modify_test_class()    
read_and_modify_array_with_manager_single_process()
read_and_modify_array_with_manager_multi_process()
read_and_modify_test_class_with_manager_single_process()
read_and_modify_test_class_with_manager_multi_process()
