import numpy

class PythonModelHolder:    
    def __init__(self, n):
        self.m = numpy.array([1e-2 for i in range(n)])
        self.nSteps = 1
        self.stepsize = 0.1
        
    def grad_step(self, x0, y):
        x  = numpy.array(x0)
        wx = numpy.dot(self.m, x)
        step = self.stepsize / (1 + self.nSteps)
        self.m += -step*(wx - y)*x
        self.nSteps += 1

    def se_loss(self, x,  y):
        wx = numpy.dot(self.m, numpy.array(x))
        return (wx - y)*(wx - y)
    

def init():
    return (PythonModelHolder(54),)

def grad(m, (x, y)):
    m[0].grad_step(x,y)
    return m

def loss(m, (x, y)):
    return m[0].se_loss(x, y)


def stopping_condition(s, loss):
    if not (s.has_key('state')):
        s['state'] = 0
    s['state'] += 1
    return s['state'] > 10

