"""
This module runs the all tests suits and produce html report
"""

import unittest
from sys_appends import *
import sys

for b in bases:
    sys.path.append(b)
    sys.path.append(b + 'unittests/')
    sys.path.append(b + 'unittests/atomic_data_processor/')
    sys.path.append(b + 'unittests/tuple_processor/')
    sys.path.append(b + 'unittests/victor_database/')
    sys.path.append(b + 'unittests/victor_file/')
    sys.path.append(b + 'src/vsql_core/utils/factored_parser/')

#atomic data processor tests
import unittests.atomic_data_processor.atomic_data_processor_read_tests       as atomic_data_processor_read_tests
import unittests.atomic_data_processor.atomic_data_processor_write_tests      as atomic_data_processor_write_tests
import unittests.atomic_data_processor.atomic_data_processor_round_trip_tests as atomic_data_processor_round_trip_tests

#tuple processor tests
import unittests.tuple_processor.tuple_reader_read_tests  as tuple_reader_read_tests
import unittests.tuple_processor.tuple_writer_write_tests as tuple_writer_write_tests
import unittests.tuple_processor.tuple_round_trip_tests   as tuple_round_trip_tests

#psql_util tests
import unittests.victor_database.victor_database_read_tests       as victor_database_read_tests
import unittests.victor_database.victor_database_write_tests      as victor_database_write_tests
import unittests.victor_database.victor_database_round_trip_tests as victor_database_round_trip_tests

#victor file tests
import unittests.victor_file.victor_file_read_tests       as victor_file_read_tests
import unittests.victor_file.victor_file_round_trip_tests as victor_file_round_trip_tests

import HTMLTestRunner
import StringIO

#atomic data processor tests
atomic_data_processor_read_suite = unittest.TestLoader().loadTestsFromTestCase(atomic_data_processor_read_tests.AtomicDataProcessorReadRegressionTests)
atomic_data_processor_write_suite = unittest.TestLoader().loadTestsFromTestCase(atomic_data_processor_write_tests.AtomicDataProcessorWriteRegressionTests)
atomic_data_processor_round_trip_suite = unittest.TestLoader().loadTestsFromTestCase(atomic_data_processor_round_trip_tests.AtomicDataProcessorRoundTripRegressionTests)

#tuple read/write tests
tuple_reader_read_suite = unittest.TestLoader().loadTestsFromTestCase(tuple_reader_read_tests.TupleReaderReadRegressionTests)
tuple_writer_write_suite = unittest.TestLoader().loadTestsFromTestCase(tuple_writer_write_tests.TupleWriterWriteRegressionTests)
tuple_round_trip_suite = unittest.TestLoader().loadTestsFromTestCase(tuple_round_trip_tests.TupleRoundTripRegressionTests)

#victor_database tests
victor_database_read_suite = unittest.TestLoader().loadTestsFromTestCase(victor_database_read_tests.VictorDBReadRegressionTests)
victor_database_write_suite = unittest.TestLoader().loadTestsFromTestCase(victor_database_write_tests.VictorDBWriteRegressionTests)
victor_database_round_trip_suite = unittest.TestLoader().loadTestsFromTestCase(victor_database_round_trip_tests.VictorDBRoundTripRegressionTests)

#victor_file tests
victor_file_read_suite = unittest.TestLoader().loadTestsFromTestCase(victor_file_read_tests.VictorFileReadRegressionTests)
victor_file_round_trip_suite = unittest.TestLoader().loadTestsFromTestCase(victor_file_round_trip_tests.VictorFileRoundTripRegressionTests)

alltests = unittest.TestSuite([atomic_data_processor_read_suite, 
                               atomic_data_processor_write_suite,
                               atomic_data_processor_round_trip_suite,
                               tuple_reader_read_suite,
                               tuple_writer_write_suite,
                               tuple_round_trip_suite,
                               victor_database_read_suite,
                               victor_database_write_suite,
                               victor_database_round_trip_suite,
                               victor_file_read_suite,
                               victor_file_round_trip_suite,
                               ])
buf = StringIO.StringIO()
runner = HTMLTestRunner.HTMLTestRunner(
    stream=buf,
    title='<Victor Test>',
    description='This demonstrates the unit tests report output by Victor.'
    )
runner.run(alltests)
print buf.getvalue()
